﻿package {
	import flash.display.Sprite;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import caurina.transitions.Tweener;
	
	public class Main extends Sprite{
		//Main의 기본 설정입니다.		
		private var _xmlURL:String = "http://apis.daum.net/search/image?apikey=DAUM_SEARCH_DEMO_APIKEY&output=xml&q=flower";
		private var _request:URLRequest = new URLRequest(_xmlURL);
		private var xml:XML;
		private var loader:URLLoader;
		private var img:ImgClip;
		private var imgNum:Number = 0;
		private var upDateChk:Boolean = true;
		
		//Loader에 XML정보를 가져옵니다. URLLoader클래스는 _request에서 텍스트, 변수형식의 데이터를 가져옵니다.		
		public function Main(){
			loader = new URLLoader(_request);
			loader.addEventListener(Event.COMPLETE, completeHandler);
		}
		//_request의 정보를 모두 가져왔을때 호출할 메서드
		private function completeHandler(evt:Event):void 
		{
			xml = new XML(loader.data);			
			img = new ImgClip(xml..thumbnail[imgNum]);
			img.clipInit = imgClipInit;
			addChild(img);
			//마우스힐을 움직이면 mouseWheelHandler함수 실행
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, mouseWheelHandler);			
		}
		//ImgClip클래스에서 이미지로드가 완료되었을때 호출되어지는 clipInit메서드에 아래코딩이 실행되어집니다.		
		//이미지의 좌표값을 stage의 중앙으로 맞춰줍니다.
		private function imgClipInit(mc:Sprite):void{
			mc.x = (stage.stageWidth - mc.width) / 2 + mc.width/2;
			mc.y = (stage.stageHeight - mc.height) / 2 + mc.height/2;
		}
		//마우스힐을 움직일때 위쪽, 아래쪽에 따라 각각 upChangeImg, downChangeImg 메서드르 호출합니다.
		private function mouseWheelHandler(evt:MouseEvent):void{
			if(img.rotationY % 180 == 0){
				if(evt.delta > 0){
					if(imgNum < xml..thumbnail.length()-1){
						upChangeImg();
					}		
				}else{
					if(imgNum > 0){						
						downChangeImg();
					}				
				}
			}
		}
		private function upChangeImg():void{			
			if (img.rotationY % 180 == 0) {
				Tweener.addTween(img, { rotationY : img.rotationY + 180, time: 0.5, transition: 'easeOut', onUpdate:upImgHandler, onComplete:CompleteHandler} );
			}
		}
		private function downChangeImg():void{
			if (img.rotationY % 180 == 0) {
				Tweener.addTween(img, { rotationY : img.rotationY - 180, time: 0.5, transition: 'easeOut', onUpdate:downImgHandler, onComplete:CompleteHandler} );
			}
		}
		//이미지가 Tweener에 의해 움직일때 이미지의 rotationY값과 upDateChk값을 확인하여 조건에 맞춰 다음 또는 이전 이미지를 보여줍니다.
		private function upImgHandler():void{			
			if (img.rotationY%180 > 90 && upDateChk == true)
			{	
			    imgNum++;
				upDateChk = false;
				img.clipURL = xml..thumbnail[imgNum];
			}
		}
		private function downImgHandler():void{
			if(img.rotationY % 180 < 90 && upDateChk == true)
			{
				imgNum--;
				upDateChk = false;
				img.clipURL = xml..thumbnail[imgNum];
			}			
		}
		//이미지 로딩이 끝났을때 upDateChk 변수값을 true로 바꿔 줍니다.
		private function CompleteHandler():void 
		{
			upDateChk = true;
		}
	}	
}

